"""This script computes interesting stats about the book Tom Sawyer (or any other book
available in .txt format)."""



from sequenceTools import * # imports all variables defined in __all__ in module sequenceTools

def fileToWordList(filename):
    """Given a file name it returns the list of words in it"""
    wordList = []
    with open(filename) as book:  # with block for opening file
        for line in book:  # iterate over each line (ending with \n)
            line = line.strip()  # .strip() removes leading and trailing whitespace.
            # .split will split a string into a list
            # based on a character (default is a space)
            wordList += line.split()
    return wordList


#  lets find out some interesting things about tom sawyer
#  words with the most number of vowels?
def mostVowelWord(wordList):
    maxVowelNum = 0
    maxVowelWord = ''
    for word in wordList:
        numVowels = countAllVowels(word)
        if numVowels > maxVowelNum:
            maxVowelNum = numVowels
            maxVowelWord = word
    return maxVowelWord
    #print('Word in Tom Sawyer with the max no of vowels is {} which has {} vowels.'.format(maxVowelWord, maxVowelNum))



# lets find out how many words in tom sawyer start and end with the same letter
# since we are looking for a collection of words, we need to store them in a list

def prettyWords(wordList):
    #numPrettyWords = wordStartEndCount(wordList)
    #print(numPrettyWords)
    return wordStartEndList(wordList)
    #print(prettyWords)


# lets find out the number of words in tomsawyer that contain a certain character

def wordsWithChar(char, num, wordList):
    charWords = []
    for word in wordList:
        if countChar(char, word) >= num:
            charWords.append(word)
    return charWords


def commonWords(wordList1, wordList2):
    commonW = []
    for word1 in wordList1:
        for word2 in wordList2:
            if word1.lower() == word2.lower():
                commonW.append(word1)
    return commonW


if __name__ == '__main__':
    #testing code here
    wordList = fileToWordList('textfiles/prideandprejudice.txt')
    #print(fileToWordList('textfiles/prideandprejudice.txt'))
    #print('The word in Pride and Prejudice with the most number of vowels', mostVowelWord(wordList))
    #print('The number of pretty words in Pride and Prejudice', len(prettyWords(wordList)))
    #print('The words in Pride and Prejudice that contain two zs:', wordsWithChar('q', 1, wordList))
    print('Names common in names of this class and Pride and Prejudice:')
    classNames = fileToWordList('textfiles/classNames.txt')
    print(set(commonWords(classNames, wordList)))


            

    
        




